<template>
  <div class="app-container">
    <el-row>
      <el-select v-model="oneTierMenu" placeholder="第一層目錄" @change="getChildrenMenu(1)">
        <el-option v-for="(i,index) in oneTierMenus" :key="index" :label="i.title" :value="i.id" />
      </el-select>
    </el-row>
    <el-row>
      <el-select v-model="twoTierMenu" placeholder="第二層目錄" @change="getChildrenMenu(2)">
        <el-option v-for="(i,index) in twoTierMenus" :key="index" :label="i.title" :value="i.id" />
      </el-select>
    </el-row>
    <el-row>
      <el-select v-model="threeTierMenu" placeholder="第三層目錄">
        <el-option v-for="(i,index) in threeTierMenus" :key="index" :label="i.title" :value="i.id" />
      </el-select>
      <el-button @click="importAction">帶入</el-button>
      <el-button @click="resetSelectAction">重置</el-button>
    </el-row>
    <el-divider />
    <el-form
      ref="form1"
      :model="dataForm[0]"
      :rules="rule"
      label-width="120px"
      size="mini"
      :inline="true"
    >
      <el-form-item label="第一層級路徑" prop="path">
        <el-input v-model="dataForm[0].path" />
      </el-form-item>
      <el-form-item label="第一層級標題" prop="title">
        <el-input v-model="dataForm[0].title" />
      </el-form-item>
      <el-form-item label="第一層級ICON" prop="icon">
        <el-select v-model="dataForm[0].icon">
          <el-option v-for="(i,index) in iconItems.icons" :key="index" :label="i" :value="i">
            <span style="float: left">{{ i }}</span>
            <span style="float: right;">
              <svg-icon :icon-class="i" />
            </span>
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" round @click="reset1Action">重置</el-button>
      </el-form-item>
    </el-form>
    <el-divider />
    <el-form
      ref="form2"
      :model="dataForm[1]"
      :rules="rule"
      label-width="120px"
      size="mini"
      :inline="true"
    >
      <el-form-item label="第二層級路徑" prop="path">
        <el-input v-model="dataForm[1].path" v-chinese />
      </el-form-item>
      <el-form-item label="第二層級標題" prop="title">
        <el-input v-model="dataForm[1].title" />
      </el-form-item>
      <el-form-item label="第二層級ICON" prop="icon">
        <el-select v-model="dataForm[1].icon">
          <el-option v-for="(i,index) in iconItems.icons" :key="index" :label="i" :value="i">
            <span style="float: left">{{ i }}</span>
            <span style="float: right;">
              <svg-icon :icon-class="i" />
            </span>
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" round @click="reset2Action">重置</el-button>
      </el-form-item>
    </el-form>
    <el-divider />
    <el-form
      ref="form3"
      :model="dataForm[2]"
      :rules="rule"
      label-width="120px"
      size="mini"
      :inline="true"
    >
      <el-form-item label="第三層級路徑" prop="path">
        <el-input v-model="dataForm[2].path" v-chinese />
      </el-form-item>
      <el-form-item label="第三層級標題" prop="title">
        <el-input v-model="dataForm[2].title" />
      </el-form-item>
      <el-form-item label="第三層級ICON" prop="icon">
        <el-select v-model="dataForm[2].icon">
          <el-option v-for="(i,index) in iconItems.icons" :key="index" :label="i" :value="i">
            <span style="float: left">{{ i }}</span>
            <span style="float: right;">
              <svg-icon :icon-class="i" />
            </span>
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" round @click="reset3Action">重置</el-button>
      </el-form-item>
    </el-form>
    <el-divider />
    <el-form
      ref="form4"
      :model="dataForm[3]"
      :rules="rule"
      label-width="120px"
      size="mini"
      :inline="true"
    >
      <el-form-item label="第四層級路徑" prop="path">
        <el-input v-model="dataForm[3].path" v-chinese />
      </el-form-item>
      <el-form-item label="第四層級標題" prop="title">
        <el-input v-model="dataForm[3].title" />
      </el-form-item>
      <el-form-item label="第四層級ICON" prop="icon">
        <el-select v-model="dataForm[3].icon">
          <el-option v-for="(i,index) in iconItems.icons" :key="index" :label="i" :value="i">
            <span style="float: left">{{ i }}</span>
            <span style="float: right;">
              <svg-icon :icon-class="i" />
            </span>
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" round @click="reset4Action">重置</el-button>
      </el-form-item>
    </el-form>
    <el-divider />
    <el-button type="primary" round @click="insertAction">新增</el-button>
    <el-button type="primary" round @click="resetAllAction">重置</el-button>
  </div>
</template>
<script>
import { iconItems, inserFormData } from './entity'
import { add, getOneTierMenu, getMenuByParent } from './action'
import { insertValid } from './rule.js'
export default {
  data() {
    return {
      oneTierMenus: [],
      twoTierMenus: [],
      threeTierMenus: [],
      oneTierMenu: '',
      twoTierMenu: '',
      threeTierMenu: '',
      dataForm: inserFormData(),
      iconItems: iconItems(),
      rule: insertValid()
    }
  },
  mounted() {
    this.getOneTierMenu()
  },
  methods: {
    resetSelectAction: function() {
      this.oneTierMenu = ''
      this.twoTierMenu = ''
      this.threeTierMenu = ''
    },
    importAction: function() {
      if (this.oneTierMenu.length > 0) {
        for (var i = 0; i < this.oneTierMenus.length; i++) {
          if (this.oneTierMenus[i].id === this.oneTierMenu) {
            this.dataForm[0].path = this.oneTierMenus[i].path
            this.dataForm[0].icon = this.oneTierMenus[i].icon
            this.dataForm[0].title = this.oneTierMenus[i].title
            break
          }
        }
      }
      if (this.twoTierMenu.length > 0) {
        for (var j = 0; j < this.twoTierMenus.length; j++) {
          if (this.twoTierMenus[j].id === this.twoTierMenu) {
            this.dataForm[1].path = this.twoTierMenus[j].path
            this.dataForm[1].icon = this.twoTierMenus[j].icon
            this.dataForm[1].title = this.twoTierMenus[j].title
            break
          }
        }
      }
      if (this.threeTierMenu.length > 0) {
        for (var k = 0; k < this.threeTierMenus.length; k++) {
          if (this.threeTierMenus[k].id === this.threeTierMenu) {
            this.dataForm[2].path = this.threeTierMenus[k].path
            this.dataForm[2].icon = this.threeTierMenus[k].icon
            this.dataForm[2].title = this.threeTierMenus[k].title
            break
          }
        }
      }
    },
    getOneTierMenu: function() {
      getOneTierMenu().then(res => {
        if (res.status === 'OK') {
          this.oneTierMenus = res.data
        }
      })
    },
    getChildrenMenu: function(val) {
      if (val === 1) {
        this.twoTierMenus = []
        this.twoTierMenu = ''
        this.threeTierMenus = []
        this.threeTierMenu = ''
        getMenuByParent({ parent: this.oneTierMenu, tier: 1 }).then(res => {
          if (res.status === 'OK') {
            this.twoTierMenus = res.data
          }
        })
      } else if (val === 2) {
        getMenuByParent({ parent: this.twoTierMenu, tier: 2 }).then(res => {
          this.threeTierMenus = []
          this.threeTierMenu = ''
          if (res.status === 'OK') {
            this.threeTierMenus = res.data
          }
        })
      }
    },
    insertAction: function() {
      var checkValid = true
      this.$refs['form1'].validate(valid => {
        if (valid) {
          checkValid = valid
        } else {
          checkValid = false
        }
      })
      this.$refs['form2'].validate(valid => {
        if (checkValid) {
          if (valid) {
            checkValid = valid
          } else {
            checkValid = false
          }
        }
      })
      this.$refs['form3'].validate(valid => {
        if (checkValid) {
          if (valid) {
            checkValid = valid
          } else {
            checkValid = false
          }
        }
      })
      this.$refs['form4'].validate(valid => {
        if (checkValid) {
          if (valid) {
            checkValid = valid
          } else {
            checkValid = false
          }
        }
      })
      if (checkValid) {
        add(this.dataForm).then(res => {
          if (res.status === 'OK') {
            alert('新增成功!')
          } else {
            alert('新增失敗!')
          }
        })
      }
    },
    limitChineseFilter: function() {
      this.$nextTick(() => {
        if (this.dataForm[0].path !== null) {
          this.dataForm[0].path = this.dataForm[0].path.replace(
            /[^\w\.\/]/gi,
            ''
          )
        }
        if (this.dataForm[1].path !== null) {
          this.dataForm[1].path = this.dataForm[1].path.replace(
            /[^\w\.\/]/gi,
            ''
          )
        }
        if (this.dataForm[2].path !== null) {
          this.dataForm[2].path = this.dataForm[2].path.replace(
            /[^\w\.\/]/gi,
            ''
          )
        }
        if (this.dataForm[3].path !== null) {
          this.dataForm[3].path = this.dataForm[3].path.replace(
            /[^\w\.\/]/gi,
            ''
          )
        }
      })
    },
    resetAllAction: function() {
      this.reset1Action()
      this.reset2Action()
      this.reset3Action()
      this.reset4Action()
    },
    reset1Action: function() {
      this.$refs['form1'].resetFields()
    },
    reset2Action: function() {
      this.$refs['form2'].resetFields()
    },
    reset3Action: function() {
      this.$refs['form3'].resetFields()
    },
    reset4Action: function() {
      this.$refs['form4'].resetFields()
    }
  }
}
</script>
